//coded by Feifei Li, contact: lifeifei@cs.bu.edu

#include <iostream>
#include <math.h>

#define DB_MAX 1e323
#define DB_MIN 1e-323

using namespace::std;
class Doublee {
	public:
    Doublee();
    Doublee(double a, double b);
    Doublee(double doubleval);
    Doublee(const Doublee& db);
    ~Doublee(); 
    double getDouble();
    void adjustExp(Doublee& t);
    void adjustAB();
    
    void add(Doublee t);
    void minus(Doublee t);
    void multiply(Doublee t);
    void divide(Doublee t);
    void assign(Doublee t);
    
    
    Doublee operator=(double value);
    Doublee operator+(double value);
    Doublee operator-(double value);
    Doublee operator/(double value);
    Doublee operator*(double value);
    bool operator>(double value);
    bool operator<(double value);
    bool operator>=(double value);
    bool operator<=(double value);
    bool operator==(double value);
    bool operator!=(double value);
    
    Doublee operator=(Doublee value);
    Doublee operator+(Doublee value);
    Doublee operator-(Doublee value);
    Doublee operator/(Doublee value);
    Doublee operator*(Doublee value);
    bool operator>(Doublee value);
    bool operator<(Doublee value);
    bool operator>=(Doublee value);
    bool operator<=(Doublee value);
    bool operator==(Doublee value);
    bool operator!=(Doublee value);


    friend Doublee operator+(double val, Doublee db);
    friend Doublee operator-(double val, Doublee db);
    friend Doublee operator*(double val, Doublee db);
    friend Doublee operator/(double val, Doublee db);
    friend bool operator>(double val, Doublee value);
    friend bool operator<(double val, Doublee value);
    friend bool operator>=(double val, Doublee value);
    friend bool operator<=(double val, Doublee value);
    friend bool operator!=(double val, Doublee value);
    friend bool operator==(double val, Doublee value);

    friend ostream & operator<<( ostream &os, Doublee &db);
 
	public:
    double a;
    double b;
};
