//coded by Feifei Li, contact: lifeifei@cs.bu.edu

#include "udb.h"
#include <queue>
#include <sys/param.h>
#include <sys/types.h>
#include <limits.h>
#include <map>
#include <ext/hash_map>
#include <ext/hash_fun.h>
#include "doublee.h"


using namespace::std;

class PrioritizeTask { 
      public : int operator()( const Tuple* x, const Tuple* y ) 
      {  
             int res=0;
             double xval=DB_MAX, yval=DB_MAX;
             if (x->qitj!=0.0) 
                 xval=x->confidence/x->qitj;
             if (y->qitj!=0.0)
                 yval=y->confidence/y->qitj; 
             if (xval > yval)
                res=1;
             else if (xval < yval)
                res=0;
             else if (xval==yval)
             {
                  res = (x->sortid<y->sortid);
             }
             return res;
      }
};

class GnuHash
{
public:
	size_t operator()(const unsigned int& x) const
	{
		__gnu_cxx::hash<const char*> H;
		char bits[4];
		memcpy(bits, &x, 4);
		return H(bits);
	}
};

class UtopkCor {
	public:
    UtopkCor(int k);
    ~UtopkCor(); 
    bool initDB(unsigned int N, char* input_file, char* xtuple_file, int xdegree, unsigned int numxtuple);
	void findTopk();
	void printQueue(priority_queue<Tuple*, vector<Tuple*>, PrioritizeTask> res);
	void printVector(priority_queue<Tuple*, vector<Tuple*>, PrioritizeTask> res);
	void test_priority_queue(priority_queue<Tuple*, vector<Tuple*>, PrioritizeTask> res);
	void printVector(map<Tuple*, Tuple*, PrioritizeTask> res);
	void test_map(map<Tuple*, Tuple*, PrioritizeTask> res);
	void printResults();
	void printStatistics();
	void getMemsize();
	void finalizeFromSnapshot();

	public:
	int k;
	unsigned int n;
	Udb* db;
	struct tms st,ed;
	double t1, t2;
	struct timeval tdiff, start, end;

	double elapsed;
	double usertime;
	double systemtime;
	double realtime;

	vector<unsigned int> dominators;
	map<Tuple*, Tuple*, PrioritizeTask> topk;
	map<Tuple*, Tuple*, PrioritizeTask> snapshot_topk;
	__gnu_cxx::hash_map<unsigned int, Tuple*, GnuHash> hatDi;
	vector<Tuple*> update_snapshot_topk;
	long double L_rhoi;
	unsigned long memusage;
    unsigned int largest_rhoi_index;
};
