//coded by Feifei Li, contact: lifeifei@cs.bu.edu

#include "utopkcor.h"

int main(int argc, char **argv)
{
	if (argc!=9)
	{
		cout<<"Usage: "<<argv[0]<<" input_file "<<" xtupleid_file " << " num_xtuple " << " xdgree "<<" k "<<" N "<<" showDB(0,1) "<<" showTopk(0,1)"<<endl;
		return -1;
	}
    
	int k=atoi(argv[5]);
	unsigned int N=atoi(argv[6]);
	int xdegree=atoi(argv[4]);
	unsigned int numxtuple=atoi(argv[3]);
	int showDB=atoi(argv[7]);
	int showTopk=atoi(argv[8]);
	
	if ((unsigned int)k> (N-numxtuple*(xdegree-1)))
    {
        cout<<"k cannot be larger than N-numxtuple*(xdgree-1) = "<< (N-numxtuple*(xdegree-1)) <<endl;
        return 1;      
    }

	
	UtopkCor a(k);	

    
	a.initDB(N, argv[1], argv[2], xdegree, numxtuple);
	if (showDB==1)
	{
	   a.db->printDB();
	   cout<<endl<<"UDB with N = "<<N<<" number of tuples "<<endl;
    }
    
	a.findTopk();
	
	if (showTopk==1)
	{
	   cout<<endl;
	   a.printResults();
	   cout<<endl<<"UTopk results for k= "<<k<<endl;
    }
    a.printStatistics();
    return 1;	
}
