//coded by Feifei Li, contact: lifeifei@cs.bu.edu

#include "udb.h"
#include <queue>
#include <sys/param.h>
#include <sys/types.h>
#include <map>
#include "doublee.h"

using namespace::std;

class PrioritizeTask { 
      public : int operator()( const Tuple &x, const Tuple &y ) 
      { return x.confidence > y.confidence; } 
};

class UtopkIndep {
	public:
    UtopkIndep(int k);
    ~UtopkIndep(); 
    bool initDB(unsigned int N, char* input_file);
	void findTopk();
	void printQueue(priority_queue<Tuple, vector<Tuple>, PrioritizeTask> res);
	void printVector(priority_queue<Tuple, vector<Tuple>, PrioritizeTask> res);
	void printResults();
	void printStatistics();
	void getMemsize();
    void stateProb(vector<unsigned int> tps, vector<Tuple> tuples);
    void finalizeFromSnapshot();

	public:
	int k;
	unsigned int n;
	Udb* db;
	struct tms st,ed;
	double t1, t2;
	struct timeval tdiff, start, end;

	double elapsed;
	double usertime;
	double systemtime;
	double realtime;
	priority_queue<Tuple, vector<Tuple>, PrioritizeTask> topk;
	priority_queue<Tuple, vector<Tuple>, PrioritizeTask> snapshot_topk;
	vector<unsigned int> update_snapshot_topk;
	long double L_rhoi;
	unsigned long memusage;
    unsigned int largest_rhoi_index;
};
