
//coded by Feifei Li, contact: lifeifei@cs.bu.edu
#include <iostream>
#include <stdio.h>
#include <math.h>
#include <vector>
#ifndef INCTUPLE
        #include "tuple.h"
        #define INCTUPLE 1
#endif

#include <map>
#include <ext/hash_map>
#include <ext/hash_fun.h>

using namespace std;

class Tpids{
      public:
        unsigned int id;
        unsigned int sortid;
      public:  
        Tpids::Tpids()
        {
            id=0;
            sortid=0;
        }
        
        Tpids::~Tpids()
        {
        }
};

class GnuHash
{
public:
	size_t operator()(const unsigned int& x) const
	{
		__gnu_cxx::hash<const char*> H;
		char bits[4];
		memcpy(bits, &x, 4);
		return H(bits);
	}
};
    
class State {
	public:
    State();
    State(bool xtuple);
    State(unsigned int length, double prob, unsigned int last_seen_sortid, bool xtuple);
    State(State& s);
    ~State(); 
    void tps_in_state(vector<Tuple> tuples);
    void update_state(Tuple tp, bool isxtuple, int index);
    void update_state_notp(Tuple tp, bool tp_couldbe_instate, double eff_confidence);
    void set_prevstate(State* s);
    friend ostream & operator<<( ostream &os, State &tp);
    unsigned long getSize();
    int findXids(unsigned int xid);
    void printXtpids();
 
	public:
    bool init;
    unsigned int length;
    unsigned int last_seen_sortid;
    unsigned int last_sortid;
    double prob;
    bool xtuple;
    State* prevstate;
    vector<Tpids> xtp_ids;
    
};
