//coded by Feifei Li, contact: lifeifei@cs.bu.edu


#include "statenox.h"
#include <stdio.h>
#include <stdlib.h>
#include <iostream>
#include<assert.h>

ostream & operator<<( ostream &os, Statenox &s ) 
{ 
        os << s.length <<" " << s.prob; 
        return ( os ); 
}

Statenox::Statenox()
{  
   this->length=0;
   this->prob=0.0;
   this->last_seen_sortid=0;
   this->xtuple=false;
   this->last_sortid=0;
   this->init=true;
   this->prevstate=NULL;
}

Statenox::Statenox(bool xtuple)
{  
   this->length=0;
   this->prob=0.0;
   this->last_seen_sortid=0;
   this->xtuple=xtuple;
   this->last_sortid=0;
   this->init=true;
   this->prevstate=NULL;
}


Statenox::Statenox(unsigned int length, double prob, unsigned int last_seen_sortid, bool xtuple)
{  
   this->length=length;
   this->prob=prob;
   this->last_seen_sortid=last_seen_sortid;
   this->xtuple=xtuple;
   this->last_sortid=0;
   this->init=true;
   this->prevstate=NULL;
}

Statenox::Statenox(Statenox& s)
{
   this->init=s.init;
   this->length=s.length;
   this->prob=s.prob;
   this->last_seen_sortid=s.last_seen_sortid;
   this->last_sortid=s.last_sortid;
   this->xtuple=s.xtuple;
   this->prevstate=s.prevstate;
}

Statenox::~Statenox()
{
}


void Statenox::set_prevstate(Statenox* s)
{
     this->prevstate=s;     
}

void Statenox::tps_in_state(vector<Tuple> tuples)
{
     vector<unsigned int> tps;
     Statenox* cur=this;
     Statenox* tmp;
     while(cur!=NULL)
     {
               if (cur->last_seen_sortid==cur->last_sortid && cur->length!=0)
               {
                     tps.push_back(cur->last_sortid);
               }
           tmp=cur;
           cur=cur->prevstate;
           if (tmp!=this)
             delete tmp;
     }
     //vector<unsigned int> ttps;
     for (int i=tps.size()-1; i>=0;i--)
     {
         cout<<tuples[tps[i]]<<endl;       
         //ttps.push_back(tps[i]);
     }
     //stateProb(ttps, tuples);   
}

void Statenox::update_state_notp(Tuple tp, bool tp_couldbe_instate, double eff_confidence)
{
   if (this->init==true)
   {
      this->last_seen_sortid=tp.sortid;
      this->prob=eff_confidence;
      this->init=false;
   }
   else
   {
      this->last_seen_sortid=tp.sortid;
      if (tp_couldbe_instate)
            this->prob=this->prob*eff_confidence;    
   }
}

void Statenox::update_state(Tuple tp, bool isxtuple)
{
     this->last_seen_sortid=tp.sortid;
     this->last_sortid=tp.sortid;
     if (xtuple==false)
        this->length++;
     else
        this->length++;   
     if (this->init==true)
     {
        this->prob=tp.confidence;
        this->init=false;
     }
     else
        this->prob=this->prob*tp.confidence;
}

unsigned long Statenox::getSize()
{
      /*state stores tp's id (or pointer) which is 4 bytes. that is the dominator factor. plus the 8 bytes of prob, and 4 bytes of last_seen_id
      if (xtuple)
            return (8+4+this->length*4);
      else
            return (8+4+this->length*4);         */
       //8 bytes of prob, 4 bytes of last_seen_id, 4 bytes of last_sortid, 4 bytes of pointer to prevstate, 4 bytes of length
       return (8+4+4+4+4);
}

void Statenox::stateProb(vector<unsigned int> tps, vector<Tuple> tuples)
{
     double prob=1.0;
     unsigned int i=0,j=0;
     while (i<tps.size())
     {
           if (tuples[j].sortid<tps[i])
              prob=prob*(1-tuples[j].confidence);
           else if (tuples[j].sortid==tps[i])
           {
              prob=prob*tuples[j].confidence;
              i++;
           }
           j++;               
     }
     cout<<"prob is "<<prob<<endl;
}

