//coded by Feifei Li, contact: lifeifei@cs.bu.edu

#include <iostream>
#include <math.h>
#include <vector>
#ifndef INCTUPLE
        #include "tuple.h"
        #define INCTUPLE 1
#endif

#include <map>
#include <ext/hash_map>
#include <ext/hash_fun.h>


using namespace::std;

class GnuHash
{
public:
	size_t operator()(const unsigned int& x) const
	{
		__gnu_cxx::hash<const char*> H;
		char bits[4];
		memcpy(bits, &x, 4);
		return H(bits);
	}
};

class Statenox {
	public:
    Statenox();
    Statenox(bool xtuple);
    Statenox(unsigned int length, double prob, unsigned int last_seen_sortid, bool xtuple);
    Statenox(Statenox& s);
    ~Statenox(); 
    void tps_in_state(vector<Tuple> tuples);
    void update_state(Tuple tp, bool isxtuple);
    void update_state_notp(Tuple tp, bool tp_couldbe_instate, double eff_confidence);
    void set_prevstate(Statenox* s);
    friend ostream & operator<<( ostream &os, Statenox &tp);
    unsigned long getSize();
 	void stateProb(vector<unsigned int> tps, vector<Tuple> tuples);
 
	public:
    bool init;
    unsigned int length;
    unsigned int last_seen_sortid;
    unsigned int last_sortid;
    double prob;
    bool xtuple;
    Statenox* prevstate;
};
