//coded by Feifei Li, contact: lifeifei@cs.bu.edu

#include "udb.h"
#include <queue>
#include <sys/param.h>
#include <sys/types.h>
#include <map>
#include <ext/hash_map>
#include <ext/hash_fun.h>
#include "state.h"


using namespace::std;


class UkrankCor {
	public:
    UkrankCor(int k);
    ~UkrankCor(); 
    bool initDB(unsigned int N, char* input_file, char* xtuple_file, int xdegree, unsigned int numxtuple);
    void findTopk();
	bool checkTerminate(vector<double> krank, vector<double>Rij);
	void printTopk();
	void test_hashmap(__gnu_cxx::hash_map<unsigned int, unsigned int, GnuHash> mp);
	void expandStates(Tuple tp);
	void printStateSize();
	void printStates(unsigned int i);
	void printStatistics();
    void printPtiUbounds();
    void pruneStates();

	public:
	int k;
	unsigned int n;
	Udb* db;
	struct tms st,ed;
	double t1, t2;
	struct timeval tdiff, start, end;

	double elapsed;
	double usertime;
	double systemtime;
	double realtime;

	vector<unsigned int> topk;
	vector<double> ubounds;
	vector<double> krank;
	vector<bool> reported;
	vector<double> Pt;
	int report;
	
	unsigned long memusage;
	unsigned long maxnum_states;
	//priority_queue<State*, vector<State*>, PrioritizeTask> pq_states;
	//__gnu_cxx::hash_map<unsigned int, State*, GnuHash> states;
	vector< vector<State*> > states;
};
