//coded by Feifei Li, contact: lifeifei@cs.bu.edu

#include "udb.h"
#include <queue>
#include <sys/param.h>
#include <sys/types.h>
#include <limits.h>
#include <map>
#include <ext/hash_map>
#include <ext/hash_fun.h>
#include "state.h"


using namespace::std;

class PrioritizeTask { 
      public : int operator()( const State* x, const State* y ) 
      {      
             int res=0;
             if (x->prob>y->prob)
                res=0;
             else if (x->prob==y->prob)
             {
                  if (x->length<y->length)
                     res=0;
                  else
                      res=1;
             }
             else
                 res=1;
             return res;
      }
};


class UtopkCor {
	public:
    UtopkCor(int k);
    ~UtopkCor(); 
    bool initDB(unsigned int N, char* input_file, char* xtuple_file, int xdegree, unsigned int numxtuple);
	void findTopk(int showTopk);
	void printQueue(priority_queue<State*, vector<State*>, PrioritizeTask> res);
	void test_priority_queue(priority_queue<State*, vector<State*>, PrioritizeTask> res);
	void printTopk(State* s);
	void printStatistics();
	void testState();

	public:
	int k;
	unsigned int n;
	Udb* db;
	struct tms st,ed;
	double t1, t2;
	struct timeval tdiff, start, end;
	State* res;

	double elapsed;
	double usertime;
	double systemtime;
	double realtime;
	unsigned long memusage;
	unsigned long maxnum_states;

	priority_queue<State*, vector<State*>, PrioritizeTask> pq_states;
};
