//coded by Feifei Li, contact: lifeifei@cs.bu.edu

#include "utopkindep.h"

bool compare_tuple_score1(Tuple t1, Tuple t2)
{
    return t1.score>=t2.score;       
} 


UtopkIndep::UtopkIndep(int k)
{
   this->k=k;    
   this->db=NULL;
   elapsed=0.0;                       
}

UtopkIndep::~UtopkIndep()
{
   if (db!=NULL)                      
      delete db;                         
}

bool UtopkIndep::initDB(unsigned int N, char* input_file)
{
   db= new Udb(N, input_file);
   if (!(db->fin))
      return false;
   db->readRecords();
   //db->sortByScore();
   return true;     
}


void UtopkIndep::findTopk()
{
   unsigned int i=0;
   int j=0;
   unsigned long curmem=0;
   
   memusage=0;
   states.resize(k+1);
   current_best=new Statenox();
   for (j=0;j<k;j++)
       states[j]=NULL;
   t1 = times(&st); 
   gettimeofday (&start,NULL);
   while (true)
   {
         Tuple tp=db->tuples[i];
         Statenox* s1=NULL;
         Statenox* s2=NULL;
         double max=0.0;
         curmem=0;     
         if (i!=0)
         {
             for (j=k;j>=0;j--)
             {
                 if (states[j]!=NULL)
                 {
                      if (max>states[j]->prob)
                            states[j]=NULL;
                      else                    
                      {                         
                            s1=new Statenox(*(states[j]));
                            s1->set_prevstate(states[j]);
                            s1->update_state_notp(tp,true,1-tp.confidence);
                            
                            if (j<k)
                            {   
                                s2=new Statenox(*(states[j]));
                                s2->set_prevstate(states[j]);
                                s2->update_state(tp,false);
                                if (s2->prob<=max)
                                {
                                   delete s2;
                                   s2=NULL;              
                                }
                                else
                                {
                                    if (states[j+1]==NULL || s2->prob>states[j+1]->prob)
                                    {
                                        states[j+1]=s2;
                                        curmem+=s2->getSize();                                   
                                        max=s2->prob;
                                    }    
                                    else
                                    {
                                        delete s2;
                                        s2=NULL;
                                    }
                                }
                            }
                            if (s1->prob<=max)
                            {              
                                delete s1;
                                s1=NULL;
                                if (s1==NULL && s2==NULL)
                                   delete states[j];
                                states[j]=NULL;
                                
                            }
                            else
                            {
                                curmem+=states[j]->getSize();
                                curmem+=s1->getSize();
                                states[j]=s1;
                                max=s1->prob;
                            }
                     }
                }
            }
         }
         else
         {
             Statenox* s0= new Statenox();
             s0->update_state_notp(tp,true,1-tp.confidence);
             states[0]=s0;
             curmem+=s0->getSize();

             Statenox* s1= new Statenox();
             s1->update_state(tp,false);
             states[1]=s1;
             curmem+=s1->getSize();
         }
         if (curmem>memusage)
            memusage=curmem;
        
         if (i>=(unsigned int)(k-1))
         {
            if (states[k]!=NULL)
            {
                if (states[k]->prob>current_best->prob)
                {
                     delete current_best;
                     current_best=new Statenox(*states[k]);
                }
            }
            if (checkStop(max)==true || i==db->N-1)
            {
               this->n=i+1;
               break;
            }
         }
         i++;
   }
   memusage+=this->k*Tuple::size(false);
   gettimeofday (&end,NULL);
   t2 = times(&ed);
   usertime=((double)(ed.tms_utime-st.tms_utime))/(HZ);
   systemtime=((double)(ed.tms_stime-st.tms_stime))/(HZ);
   realtime=((double)(t2-t1))/(HZ);
   db->timeval_subtract(&tdiff, &end, &start);
   elapsed=tdiff.tv_sec+tdiff.tv_usec/1000000.0;
}


/*void UtopkIndep::findTopk()
{
   unsigned int i=0;
   unsigned int j=0;
   unsigned long curmem=0;
   
   
   memusage=0;
   states.resize(k+1);
   current_best=new State();
   for (j=0;j<=(unsigned int)k;j++)
       states[j]=NULL;
   t1 = times(&st); 
   gettimeofday (&start,NULL);
   while (true)
   {
         Tuple tp=db->tuples[i];
         //State* tmps=NULL;
         State* prev=NULL;
         State* s1=NULL;
         State* s2=NULL;
         double max=0.0;
         if (i!=0)
         {
             curmem=0;     
             for (j=0;j<states.size();j++)
             {
                 if (states[j]!=NULL)
                 {
                      s1=new State(*(states[j]));
                      s2=new State(*(states[j]));
                      s1->set_prevstate(states[j]);
                      s2->set_prevstate(states[j]);
                      curmem+=states[j]->getSize();
                      states[j]=s1;
                      
                      s1->update_state_notp(tp,true,1-tp.confidence);
                      
                      if (prev!=NULL)
                      {
                         if (s1->prob<prev->prob)
                         {
                            states[j]=prev;
                            //delete s;
                            prev=NULL;
                         }
                         else
                         {
                             //states[j]=s1;
                             delete prev;
                             prev=NULL;
                         }
                      }
                      s2->update_state(tp,false);
                      prev=s2;
                 }
                 else
                 {
                     if (prev!=NULL)
                     {
                        states[j]=prev;
                        prev=NULL;
                     }
                 }
                 if (states[j]!=NULL)
                 {
                    curmem+=states[j]->getSize();
                    //if (states[j]->prob>max)
                        //max=states[j]->prob; 
                 }
             }
         }
         else
         {
             State* s0= new State();
             s0->update_state_notp(tp,true,1-tp.confidence);
             states[0]=s0;

             State* s1= new State();
             s1->update_state(tp,false);
             states[1]=s1;
         }
         if (curmem>memusage)
            memusage=curmem;
         max=pruneStates();
        
         if (i>=(unsigned int)(k-1))
         {
            if (states[k]!=NULL)
            {
                if (states[k]->prob>current_best->prob)
                {
                     delete current_best;
                     current_best=new State(*states[k]);
                }
            }
            if (checkStop(max)==true || i==db->N-1)
            {
               this->n=i+1;
               break;
            }
         }
         i++;
   }
   memusage+=this->k*Tuple::size(false);
   gettimeofday (&end,NULL);
   t2 = times(&ed);
   usertime=((double)(ed.tms_utime-st.tms_utime))/(HZ);
   systemtime=((double)(ed.tms_stime-st.tms_stime))/(HZ);
   realtime=((double)(t2-t1))/(HZ);
   db->timeval_subtract(&tdiff, &end, &start);
   elapsed=tdiff.tv_sec+tdiff.tv_usec/1000000.0;
}*/

void UtopkIndep::printStatistics()
{	
    cout<<endl<<"scan depth: "<<this->n<<" "<<"utopk prob: "<<current_best->prob<<endl<<endl;
    printf("user time=%f \n", usertime);
    printf("system time=%f \n", systemtime);
    printf("real time=%f \n", realtime);
    printf("clock time=%f \n", elapsed);
    cout<<"max mem usage(in bytes)= "<<memusage<<endl;
    cout<<"max mem usage(in KB)= "<<(double)memusage/1024.0<<endl;
    cout<<"max mem usage(in MB)= "<<(double)memusage/(1024.0*1024.0)<<endl;
 
}


double UtopkIndep::pruneStates()
{
     int j;
     double max=0.0;
     for (j=k;j>=0;j--)
     {
         if (states[j]!=NULL)
         { 
              if ( states[j]->prob < max)
              {
                  //delete states[j];
                  states[j]=NULL;
              }
              else
              {
                  max=states[j]->prob;
              }  
         }
     }
     return max;
}

bool UtopkIndep::checkStop(double max)
{
     bool stop=false;
     if (states[k]!=NULL)
     { 
          if (states[k]->prob>=max)
             stop=true;
     }
     return stop;
}

void UtopkIndep::printResults(Statenox* s)
{
     if (s==NULL)
     {
        cout<<"sth is wrong!!" <<endl;
        return;
     }
     s->tps_in_state(db->tuples);
     
     /*cout<<endl<<"scan depth: "<<this->n<<endl;
     cout<<endl<<"state information: length + prob"<<endl;
     cout<<*s<<endl<<endl;*/
}

void UtopkIndep::printStates()
{
     for (int i=0;i<=k;i++)
     {
         Statenox* s=states[i];
         if (s!=NULL)
         {
            cout<<"state size "<<i<<endl;
            cout<<(*s)<<endl;
            s->tps_in_state(db->tuples);
            cout<<endl;
         }    
     }     
}

void UtopkIndep::getMemsize()
{
     //size is determined by the number of states kept and each state's size.
     memusage=0;
     for (int i=0;i<k+1;i++)
     {
         memusage+=states[i]->getSize();
     }
}
