//coded by Feifei Li, contact: lifeifei@cs.bu.edu

#include "udb.h"
#include <queue>
#include <sys/param.h>
#include <sys/types.h>
#include "statenox.h"

using namespace::std;

class PrioritizeTask { 
      public : int operator()( const Tuple &x, const Tuple &y ) 
      { return x.confidence > y.confidence; } 
};

class UtopkIndep {
	public:
    UtopkIndep(int k);
    ~UtopkIndep(); 
    bool initDB(unsigned int N, char* input_file);
	void findTopk();
	double pruneStates();
	bool checkStop(double max);
	void printResults(Statenox* s);
	void printStates();
	void printStatistics();
	void getMemsize();

	public:
	int k;
	unsigned int n;
	Udb* db;
	struct tms st,ed;
	double t1, t2;
	struct timeval tdiff, start, end;

	double elapsed;
	double usertime;
	double systemtime;
	double realtime;
	unsigned long memusage;

	Statenox* current_best;
	
	vector<Statenox*> states;
};
